/* rectick.c: tty record output for backtick */
/* $Id: rectick.c,v 1.4 2003/11/21 09:44:10 knok Exp $ */

/*
Copyright (C) 2003 NOKUBI Takatsugu <knok@daionet.gr.jp>
This is free software with ABSOLUTELY NO WARRANTY.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA
 */

#include <stdio.h>
#include <string.h>

#include "gnet.h"

int settermraw(void);
void resetterm(void);
void sighandler(int);
void putbuf();
void rotbuf(char);

char buf[8];

int main(int argc, char *argv[])
{
  GUnixSocket * gs, *gc;
  GIOChannel *io;
  memset(buf, 0, 8);
  //tinit();
  gs = gnet_unix_socket_server_new("/tmp/backtick");
  gc = gnet_unix_socket_server_accept(gs);
  io = gnet_unix_socket_get_io_channel(gc);
  putbuf();
  while (1) {
      GIOError ge;
    char tmp[1024];
    gsize readp;
    tmp[0] = 'X';
    ge = gnet_io_channel_readline(io, tmp, 1023, &readp);
    if (ge != G_IO_ERROR_NONE)
	break;
    if (readp == 0)
	break;
    rotbuf(tmp[0]);
    putbuf();
  }
  return 0;
}

void putbuf()
{
  int i = 8 - 1;
  for (; i >= 0; i --) {
      if (buf[i] != 0)
	  printf("[%c] ", buf[i]);
  }
  printf("\n");
  fflush(stdout);
}

void rotbuf(char c)
{
  int i = 7;
  for (; i >= 0; i --) {
    buf[i + 1] = buf[i];
  }
  buf[0] = c;
}
